Subject: Re: linux-next: build failure after merge of the rust-pin-init tree

From: "Benno Lossin" <[email-masked]>
Date: Tue, 10 Jun 2025 09:59:52 +0200

On Tue Jun 10, 2025 at 6:22 AM CEST, Stephen Rothwell wrote:
> Hi all,
>
> After merging the rust-pin-init tree, today's linux-next build (x86_64
> allmodconfig) failed like this:
>
> error[E0282]: type annotations needed
>    --> rust/kernel/configfs.rs:154:26
>     |
> 154 |             subsystem <- pin_init::zeroed().chain(
>     |                          ^^^^^^^^^^^^^^^^ cannot infer type of the type parameter `T` declared on the function `zeroed`
>     |
> help: consider specifying the generic argument
>     |
> 154 |             subsystem <- pin_init::zeroed::<T>().chain(
>     |                                          +++++
>
> error[E0282]: type annotations needed
>    --> rust/kernel/configfs.rs:264:22
>     |
> 264 |             group <- pin_init::zeroed().chain(|v: &mut Opaque<bindings::config_group>| {
>     |                      ^^^^^^^^^^^^^^^^ cannot infer type of the type parameter `T` declared on the function `zeroed`
>     |
> help: consider specifying the generic argument
>     |
> 264 |             group <- pin_init::zeroed::<T>().chain(|v: &mut Opaque<bindings::config_group>| {
>     |                                      +++++
>
> error: aborting due to 2 previous errors
>
> For more information about this error, try `rustc --explain E0282`.
>
> Caused by commit
>
>   0bcaea04244b ("rust: pin-init: rename `zeroed` to `init_zeroed`")
>
> I have used the rust-pin-init tree from next-20250606 for today.

Thanks for catching this! I didn't test with `CONFIG_CONFIGFS=y`, so the
code was cfg'd out... I'll add it to my tests.

@Andreas I'll send a new version of the commit above with configfs
changed.

---
Cheers,
Benno